/*
    CSC714 Term Project

    Task Scheduling Simulator

    Group Info:

    sykang      Sangyeol    Kang
    kabhavsa    Kinjal      Bhavsar 
*/

#ifndef _SCHED_H_
#define _SCHED_H_

#define TRUE    (1)
#define FALSE  (0)
#define MAX_LEN_STR (0x4F)

#define MAX_TASK       (32)    // Change the number of tasks if more
#define MAX_PRIORITY   (0)

//defining states
#define READY     (1)
#define RUNNING   (2)
#define BLOCKED   (4)
#define OVER      (8)

typedef enum
{
  FIXED,
  RM,
  DM,
  EDF,
  FIXED_P,  
  RM_P,
  DM_P,
  FIXED_PTS,
  RM_PTS,
  DM_PTS,
} SCHEDULE_n;

typedef struct qnode_t
{
    unsigned int priority;
    unsigned int taskid;
    unsigned int state;
    unsigned int pth;
    unsigned int deadline;
    unsigned int left;
    struct qnode_t *next;
} *qnode;

typedef struct instance
{
    unsigned int num;
    unsigned int state;
    unsigned int arrival;
    unsigned int time_left;
    unsigned int cDeadline;
    unsigned int missDeadline;
} instance_t;

// Structure containing task information
typedef struct taskset
{
    unsigned int ID;
    char        *name;
    unsigned int phase;
    unsigned int period;
    unsigned int exec;
    unsigned int bcet;
    unsigned int wcet;
    unsigned int deadline;
    unsigned int priority;
    unsigned int PT;
    instance_t   cInstance;
    //struct qnode_t *c;
} tasks_t;

//State structure showing system state
typedef struct sys_state
{
    unsigned int sys_time;
    unsigned int num_tasks;
    unsigned int sys_prio;
    unsigned int exe_task;
    unsigned int running;
    struct qnode_t *cjob;
    unsigned int hyperperiod;
    unsigned int sim_time;
    SCHEDULE_n   scheme;
    unsigned int PTS;
    unsigned int preemptive;
    char scheme_name[MAX_LEN_STR];
} state_t;


int main(int argc, char *argv[]);
int parseInput(char *fn);
int verifyInput(void);
int init_simulator(char *fin);
int init_state(void);
void schedule_taskset(void);
int GCD(int a, int b);
int LCM(int a, int b);
void state_handler(void);
void check_deadline(void);
void scheduler(void);
int calcPriority(SCHEDULE_n type);
int calcMPT(void);
int calcWCRT(int taskID);
int genOutput(void);

#endif

